SystemOrganization addCategory: #'OmniST-Benchmarks-Core'!

BenchmarkGameSuite subclass: #OstBenchGameSuite
	instanceVariableNames: 'domain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Benchmarks-Core'!

!OstBenchGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/6/2013 23:09'!
benchBinaryTrees
	| result problemSize |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
							            ifNil: [ OstBGBinaryTrees defaultProblemSize ].

	[ | bench |
	  bench  := OstBGBinaryTrees new.
	  result := bench binarytrees: problemSize to: (TextStream with: String new).
	] omni: domain.

	^ result! !

!OstBenchGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/6/2013 23:09'!
benchChameleons
	| result problemSize |
	
	self error: 'This benchmark seems to be currently broken in the OmniST implementation.'.
	
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								         ifNil: [ OstBGChameleons defaultProblemSize ].
	
	[ result := OstBGChameleons chameneos: problemSize ] omni: domain.

	^ result! !

!OstBenchGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/6/2013 23:09'!
benchChameneosRedux
	| result report problemSize |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								         ifNil: [ OstBGChameneosRedux defaultProblemSize ].
	

	[report := TextStream with: String new.
	 result := OstBGChameneosRedux new runBenchMark: problemSize on: report
	] omni: domain.

	^ result! !

!OstBenchGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/5/2013 00:23'!
benchFannkuchRedux
	| result report problemSize |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								         ifNil:    [ OstBGFannkuchRedux defaultProblemSize ].
	

	[report := TextStream with: String new.
	 result := OstBGFannkuchRedux fannkuchRedux: problemSize to: report
	] omni: domain.

	^ result! !

!OstBenchGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/5/2013 00:44'!
benchFasta
	| out problemSize |
	problemSize := self problemSize
		ifNotNilDo: [:ps | ps ]
		ifNil:      [ OstBGFasta defaultProblemSize ].  
	
	[out := TextStream with: String new.
	 OstBGFasta fasta: problemSize to: out. ] omni: domain.

	^ out! !

!OstBenchGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/7/2013 14:51'!
benchKNucleotide
	| bench input result problemSize output |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
							            ifNil:    [ OstBGKNucleotide defaultProblemSize ].
	
	[bench  := OstBGKNucleotide new.
	 input  := ReadStream on: (BGFastaCache forFasta: problemSize).
	 result := TextStream with: String new.
	 output := bench knucleotide5From: input to: result.
	] omni: domain.

	^ output! !

!OstBenchGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/6/2013 23:05'!
benchMandelbrot
	| result bench problemSize |
	bench := OstBGMandelbrot new.
	problemSize := self problemSize ifNotNil: [:ps | ps ]
							            ifNil:    [ OstBGMandelbrot defaultProblemSize ].
							
	[ result := OstArray new: problemSize * problemSize / 8.
	  bench mandelbrot2: problemSize to: result.
	] omni: domain.

	^ result! !

!OstBenchGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/6/2013 23:08'!
benchMeteor
	| problemSize result |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								  ifNil: [ OstBGMeteor defaultProblemSize ].
	
	[result := OstBGMeteor meteor: problemSize] omni: domain.
	^ result! !

!OstBenchGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/6/2013 23:09'!
benchNBody
	| problemSize |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								  ifNil: [ OstBGNBody defaultProblemSize ].

	[ OstBGNBody nbody: problemSize ] omni: domain! !

!OstBenchGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/6/2013 23:09'!
benchPiDigits
	| result problemSize |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								         ifNil:    [ OstBGPiDigits defaultProblemSize ].
	[ result := OstBGPiDigits piDigits: problemSize ] omni: domain.

	^ result! !

!OstBenchGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/7/2013 15:03'!
benchRegexDNA
	| problemSize |
	problemSize := self problemSize
		ifNotNil: [:ps | ps ]
		ifNil:    [ OstBGRegexDNA defaultProblemSize ].
	
	[OstBGRegexDNA regexdna: problemSize] omni: domain.! !

!OstBenchGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/7/2013 15:11'!
benchReverseComplement
	| problemSize |
	problemSize := self problemSize
		ifNotNil: [:ps | ps ]
		ifNil:    [ BGReverseComplement defaultProblemSize ].
	
	[BGReverseComplement revcomp: problemSize] omni: domain! !

!OstBenchGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 4/30/2013 22:38'!
benchSpectralNorm
	| bench problemSize result |
	bench := OstBGSpectralNorm new.
	problemSize := self problemSize ifNotNil: [:ps | ps ]
							            ifNil:    [ OstBGSpectralNorm defaultProblemSize ].

	[ result := bench spectralnorm: problemSize ] omni: domain.

	^ result! !

!OstBenchGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/7/2013 15:51'!
benchThreadRing
	| problemSize result |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								  ifNil: [ BGThreadRing defaultProblemSize ].

	[ result := BGThreadRing threadring: problemSize ]  omni: domain.

	^ result! !

!OstBenchGameSuite methodsFor: 'running' stamp: 'StefanMarr 9/6/2012 18:06'!
setUp
	domain := OstDomain new.! !

SMarkCompiler subclass: #OstBenchCompiler
	instanceVariableNames: 'domain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Benchmarks-Core'!

!OstBenchCompiler methodsFor: 'benchmarking' stamp: 'StefanMarr 9/6/2012 18:09'!
benchCompiler
	[super benchCompiler] omni: domain! !

!OstBenchCompiler methodsFor: 'running' stamp: 'StefanMarr 9/6/2012 18:09'!
setUp
	domain := OstDomain new.! !

SMarkSlopstone subclass: #OstBenchSlopstone
	instanceVariableNames: 'domain omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Benchmarks-Core'!

!OstBenchSlopstone class methodsFor: 'class initialization' stamp: 'StefanMarr 5/7/2013 17:08'!
initialize
	OstObject omnifyClass: self.! !

!OstBenchSlopstone methodsFor: 'benchmarking' stamp: 'StefanMarr 5/7/2013 17:43'!
benchStone
	| n |
	n := self problemSize.
	n > SmallInteger maxVal
		ifTrue: [ self error: 'Count exceeded max small int.' ].
	
	[o := obj new.
	 1 to: n do: [:i | self doIntAdd         ].
	 1 to: n do: [:i | self doFloatAdd       ].
	 1 to: n do: [:i | self doStringAccess   ].
	 1 to: n do: [:i | self doObjectCreation ].
	 1 to: n do: [:i | self doObjectCopy     ].
	 1 to: n do: [:i | self doPerform        ].
	 1 to: n do: [:i | self doBlockValue     ]
	] omni: domain.! !

!OstBenchSlopstone methodsFor: 'initialize-release' stamp: 'StefanMarr 5/7/2013 17:25'!
initialize
	obj := OstObject.! !

!OstBenchSlopstone methodsFor: 'omni reflection' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBenchSlopstone methodsFor: 'omni reflection' stamp: 'StefanMarr 1/3/2012 14:04'!
omniDomain: aDomain
	omniDomain := aDomain! !

!OstBenchSlopstone methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector on: self. ]
	! !

!OstBenchSlopstone methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector lookup: cls
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector lookup: cls on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector lookup: cls on: self. ]
	! !

!OstBenchSlopstone methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 of: aSelector on: self ]! !

!OstBenchSlopstone methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1 with: p2
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 with: p2 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 with: p2 of: aSelector on: self ]! !

!OstBenchSlopstone methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
		! !

!OstBenchSlopstone methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]! !

!OstBenchSlopstone methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]! !

!OstBenchSlopstone methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]! !

!OstBenchSlopstone methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]! !

!OstBenchSlopstone methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]! !

!OstBenchSlopstone methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]! !

!OstBenchSlopstone methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]! !

!OstBenchSlopstone methodsFor: 'benchmarking' stamp: 'StefanMarr 5/7/2013 17:50'!
setUp
	super setUp.
	domain := OstDomain new.
	self initialize.! !

SMarkSmopstone subclass: #OstBenchSmopstone
	instanceVariableNames: 'domain omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Benchmarks-Core'!

!OstBenchSmopstone class methodsFor: 'class initialization' stamp: 'StefanMarr 5/7/2013 20:23'!
initialize
	OstObject omnifyClass: self.! !

!OstBenchSmopstone methodsFor: 'benchmarking' stamp: 'StefanMarr 9/6/2012 18:12'!
benchStone
	[super benchStone] omni: domain.! !

!OstBenchSmopstone methodsFor: 'omni reflection' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBenchSmopstone methodsFor: 'omni reflection' stamp: 'StefanMarr 1/3/2012 14:04'!
omniDomain: aDomain
	omniDomain := aDomain! !

!OstBenchSmopstone methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector on: self. ]
	! !

!OstBenchSmopstone methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector lookup: cls
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector lookup: cls on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector lookup: cls on: self. ]
	! !

!OstBenchSmopstone methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 of: aSelector on: self ]! !

!OstBenchSmopstone methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1 with: p2
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 with: p2 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 with: p2 of: aSelector on: self ]! !

!OstBenchSmopstone methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
		! !

!OstBenchSmopstone methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]! !

!OstBenchSmopstone methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]! !

!OstBenchSmopstone methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]! !

!OstBenchSmopstone methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]! !

!OstBenchSmopstone methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]! !

!OstBenchSmopstone methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]! !

!OstBenchSmopstone methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]! !

!OstBenchSmopstone methodsFor: 'benchmarking' stamp: 'StefanMarr 5/7/2013 19:28'!
setUp
	ordCollectionFact := OstOrderedCollection.
	intervalFact      := OstInterval.
	rectFactory       := OstRectangle.
	sortedColFact     := OstSortedCollection.
	arrFact           := OstArray.
	setFact           := OstSet.
	pointFact         := OstPoint.
	
	domain            := OstDomain new.! !

SMarkLoops subclass: #OstBenchLoops
	instanceVariableNames: 'domain omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Benchmarks-Core'!

!OstBenchLoops commentStamp: 'StefanMarr 9/6/2012 18:00' prior: 0!
OstBenchLoops relies on the SMarkLoops benchmarks but will execute them in the context of a domain.!

!OstBenchLoops class methodsFor: 'class initialization' stamp: 'StefanMarr 4/27/2013 19:29'!
initialize 
	OstObject omnifyClass: self.! !

!OstBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 5/8/2013 13:46'!
benchArrayAccess
	[| i array obj |
	
	array := OstArray new: 1.
	obj   := OstObject new.
	
	i := self problemSize.
	[i > 0] whileTrue: [
		array at: 1.
		array at: 1 put: obj.
		
		i := i - 1.
	]] omni: domain.! !

!OstBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 9/6/2012 18:02'!
benchClassVarBinding
	[super benchClassVarBinding ] omni: domain.! !

!OstBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 9/6/2012 18:02'!
benchFloatLoop
	[super benchFloatLoop ] omni: domain.! !

!OstBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 9/6/2012 18:02'!
benchInstVarAccess
	[super benchInstVarAccess ] omni: domain.! !

!OstBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 9/6/2012 18:02'!
benchIntLoop
	[super benchIntLoop ] omni: domain.! !

!OstBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 9/6/2012 18:03'!
benchSend
	[super benchSend ] omni: domain.! !

!OstBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 9/6/2012 18:03'!
benchSendWithManyArguments
	[super benchSendWithManyArguments ] omni: domain.! !

!OstBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 1/3/2012 14:04'!
omniDomain: aDomain
	omniDomain := aDomain! !

!OstBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector on: self. ]
	! !

!OstBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:26'!
requestExecutionOf: aSelector lookup: cls
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecutionOf: aSelector lookup: cls on: self. ]
	  ifFalse: [ ^ omniDomain external_requestExecutionOf: aSelector lookup: cls on: self. ]
	! !

!OstBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 of: aSelector on: self ]! !

!OstBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:27'!
requestExecutionOf: aSelector with: p1 with: p2
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1 with: p2 of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1 with: p2 of: aSelector on: self ]! !

!OstBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3
		of: aSelector on: self ]
		! !

!OstBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:28'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4
		of: aSelector on: self ]! !

!OstBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5
		of: aSelector on: self ]! !

!OstBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:29'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6
		of: aSelector on: self ]! !

!OstBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
		of: aSelector on: self ]! !

!OstBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:31'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
		of: aSelector on: self ]! !

!OstBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
		of: aSelector on: self ]! !

!OstBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 1/29/2013 20:32'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
	<omniUnenforced>
	Processor activeProcess omniDomain == omniDomain
	  ifTrue:  [ ^ omniDomain internal_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]
	  ifFalse: [ ^ omniDomain external_requestExecution: p1
		with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
		of: aSelector on: self ]! !

!OstBenchLoops methodsFor: 'running' stamp: 'StefanMarr 9/6/2012 18:01'!
setUp
	domain := OstDomain new.! !
OstBenchLoops initialize!
OstBenchSmopstone initialize!
OstBenchSlopstone initialize!
